"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var command_1 = require("./command");
var get_stdin_1 = __importDefault(require("get-stdin"));
var meow_1 = __importDefault(require("meow"));
var help = "\nUsage\n\t$ markuplint <HTML file pathes (glob format)>\n\t$ <stdout> | markuplint\n\nOptions\n\t--config-file,  -c FILE_PATH  Ruleset file path.\n\t--fix,                        Fix HTML.\n\t--format,       -f FORMAT     Output format. Support \"JSON\", \"Simple\" and \"Standard\". Default: \"Standard\".\n\t--no-color,                   Output no color.\n\t--problem-only, -p            Output only problems, without passeds.\n\n\t--help,         -h            Show help.\n\t--version,      -v            Show version.\n\nExamples\n\t$ markuplint verifyee.html --ruleset path/to/.markuplintrc\n\t$ cat verifyee.html | markuplint\n";
var cli = meow_1.default(help, {
    flags: {
        configFile: {
            type: 'string',
            alias: 'c',
        },
        fix: {
            type: 'boolean',
        },
        format: {
            type: 'string',
            alias: 'f',
        },
        color: {
            type: 'boolean',
            default: true,
        },
        problemOnly: {
            type: 'boolean',
            alias: 'p',
        },
    },
});
if (cli.flags.v) {
    cli.showVersion();
}
if (cli.flags.h) {
    cli.showHelp();
}
if (cli.input.length) {
    command_1.command(__assign({ files: cli.input }, cli.flags));
}
get_stdin_1.default().then(function (stdin) {
    var html = stdin;
    if (!html) {
        return;
    }
    command_1.command(__assign({ codes: html }, cli.flags));
});
