"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var file_resolver_1 = require("@markuplint/file-resolver");
function resolveConfigs(files, options) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var workspace, configs, configSet, filePath, _files, _i, files_1, file, configSetNearbyCWD, _b, files_2, file, configSet;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    workspace = (_a = options.workspace, (_a !== null && _a !== void 0 ? _a : process.cwd()));
                    configs = new Map();
                    if (!options.config) return [3 /*break*/, 5];
                    configSet = void 0;
                    if (!(typeof options.config === 'string')) return [3 /*break*/, 2];
                    return [4 /*yield*/, file_resolver_1.loadConfigFile(options.config)];
                case 1:
                    configSet = _c.sent();
                    return [3 /*break*/, 4];
                case 2:
                    filePath = workspace + "/__NO_FILE__";
                    _files = new Set([filePath]);
                    return [4 /*yield*/, file_resolver_1.recursiveLoad(options.config, filePath, _files, true)];
                case 3:
                    configSet = _c.sent();
                    _c.label = 4;
                case 4:
                    if (configSet) {
                        for (_i = 0, files_1 = files; _i < files_1.length; _i++) {
                            file = files_1[_i];
                            configs.set(file, configSet);
                        }
                    }
                    return [3 /*break*/, 12];
                case 5:
                    configSetNearbyCWD = void 0;
                    _b = 0, files_2 = files;
                    _c.label = 6;
                case 6:
                    if (!(_b < files_2.length)) return [3 /*break*/, 12];
                    file = files_2[_b];
                    return [4 /*yield*/, file_resolver_1.searchConfigFile(file.path)];
                case 7:
                    configSet = _c.sent();
                    if (!configSet) return [3 /*break*/, 8];
                    configs.set(file, configSet);
                    return [3 /*break*/, 11];
                case 8:
                    if (!!configSetNearbyCWD) return [3 /*break*/, 10];
                    return [4 /*yield*/, file_resolver_1.searchConfigFile(workspace)];
                case 9:
                    configSetNearbyCWD = _c.sent();
                    _c.label = 10;
                case 10:
                    if (configSetNearbyCWD) {
                        configs.set(file, configSetNearbyCWD);
                    }
                    _c.label = 11;
                case 11:
                    _b++;
                    return [3 /*break*/, 6];
                case 12: return [2 /*return*/, configs];
            }
        });
    });
}
exports.resolveConfigs = resolveConfigs;
