"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var file_resolver_1 = require("@markuplint/file-resolver");
function resolveLintTargetFiles(options) {
    return __awaiter(this, void 0, void 0, function () {
        var files, filePathes, _i, filePathes_1, filePath, _a, _b, _c, codes, names_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    files = [];
                    if (!options.files) return [3 /*break*/, 5];
                    filePathes = Array.isArray(options.files) ? options.files : [options.files];
                    _i = 0, filePathes_1 = filePathes;
                    _d.label = 1;
                case 1:
                    if (!(_i < filePathes_1.length)) return [3 /*break*/, 4];
                    filePath = filePathes_1[_i];
                    _b = (_a = files.push).apply;
                    _c = [files];
                    return [4 /*yield*/, file_resolver_1.getFiles(filePath)];
                case 2:
                    _b.apply(_a, _c.concat([(_d.sent())]));
                    if (!files.length) {
                        throw new Error("\"" + options.files + "\" is not found.");
                    }
                    _d.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 6];
                case 5:
                    if (options.sourceCodes) {
                        codes = Array.isArray(options.sourceCodes) ? options.sourceCodes : [options.sourceCodes];
                        names_1 = Array.isArray(options.names) ? options.names : options.names ? [options.names] : [];
                        files.push.apply(files, codes.map(function (code, i) { return file_resolver_1.getAnonymousFile(code, options.workspace, names_1[i]); }));
                    }
                    _d.label = 6;
                case 6: return [2 /*return*/, files];
            }
        });
    });
}
exports.resolveLintTargetFiles = resolveLintTargetFiles;
