"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ml_core_1 = require("@markuplint/ml-core");
var get_messenger_1 = require("./get-messenger");
var module_auto_loader_1 = require("./module-auto-loader");
var path_1 = __importDefault(require("path"));
var util_1 = require("./util");
function verifyFile(file, configs, rulesAutoResolve, rules, locale, fix) {
    return __awaiter(this, void 0, void 0, function () {
        var configSet, parserModName, _i, _a, pattern, parser, ruleset, additionalRules, sourceCode, messenger, core, results;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    configSet = configs.get(file) || {
                        config: {},
                        files: new Set(),
                        errs: [],
                    };
                    parserModName = '@markuplint/html-parser';
                    if (configSet.config.parser) {
                        for (_i = 0, _a = Object.keys(configSet.config.parser); _i < _a.length; _i++) {
                            pattern = _a[_i];
                            if (path_1.default.basename(file.path).match(util_1.toRegxp(pattern))) {
                                parserModName = configSet.config.parser[pattern];
                            }
                        }
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require(parserModName)); })];
                case 1:
                    parser = _b.sent();
                    ruleset = ml_core_1.convertRuleset(configSet.config);
                    if (!rulesAutoResolve) return [3 /*break*/, 3];
                    return [4 /*yield*/, module_auto_loader_1.moduleAutoLoader(ruleset)];
                case 2:
                    additionalRules = (_b.sent()).rules;
                    rules = rules.concat.apply(rules, additionalRules);
                    _b.label = 3;
                case 3: return [4 /*yield*/, file.getContext()];
                case 4:
                    sourceCode = _b.sent();
                    return [4 /*yield*/, get_messenger_1.getMessenger(locale)];
                case 5:
                    messenger = _b.sent();
                    core = new ml_core_1.MLCore(parser, sourceCode, ruleset, rules, messenger);
                    return [4 /*yield*/, core.verify(fix)];
                case 6:
                    results = _b.sent();
                    return [2 /*return*/, {
                            results: results,
                            filePath: file.path,
                            sourceCode: sourceCode,
                            fixedCode: core.document.toString(),
                            document: core.document,
                            parser: parserModName,
                            locale: locale,
                            ruleset: ruleset,
                            configSet: {
                                config: configSet.config,
                                files: Array.from(configSet.files),
                                error: configSet.errs.map(function (e) { return "" + e; }),
                            },
                        }];
            }
        });
    });
}
exports.verifyFile = verifyFile;
